#ifndef _GRAFTYPE_
  #define _GRAFTYPE_ 1

class           Graftype
  {

  AnsiString    Knude[100];
  int           Kant[100][100];
  int           Last;

  public:

  Graftype      ();

  ~Graftype     ();

  void          AddNode (const AnsiString &s);
  void          AddEdge (const AnsiString &s1,
			    const AnsiString &s2, int vaegt);

  void          DeleteNode (const AnsiString &s);
  void          DeleteEdge (const AnsiString &s1,
			    const AnsiString &s2);

  bool          Contains (const AnsiString &s);
  bool          IsAdjacent (const AnsiString &s1, const AnsiString &s2);
  int		    Weight (const AnsiString &s1, const AnsiString &s2);

  protected:

  int           Plads(const AnsiString &s);
  int           Antal();
  String        WhichNode(int i);

  };

// Implementation

  Graftype::Graftype      ()
    {
    int i, j;
    for (i = 0; i < 100; i++)
      for (j = 0; j < 100; j++)
	Kant[i][j] = -1;
    Last = 0;
    }

  Graftype::~Graftype     ()
    {
    }

  void          Graftype::AddNode (const AnsiString &s)
    { // Pre: NOT Contains (s)
    Knude[Last] = s;
    Last++;
    }

  void          Graftype::AddEdge (const AnsiString &s1,
			    const AnsiString &s2, int vaegt)
    { // Pre: Contains(s1) AND Contains(s2)
    Kant[Plads(s1)][Plads(s2)] = vaegt;
    Kant[Plads(s2)][Plads(s1)] = vaegt;
    }

  void          DeleteNode (const AnsiString &s)
    {
    }

  void          DeleteEdge (const AnsiString &s1,
			    const AnsiString &s2)
    {
    }

  bool          Graftype::Contains (const AnsiString &s)
    {
    return (Plads(s) > -1);
    }

  bool          Graftype::IsAdjacent (const AnsiString &s1,
				      const AnsiString &s2)
    {
    return (Kant[Plads(s1)][Plads(s2)] > -1);
    }

  int           Graftype::Weight (const AnsiString &s1,
				  const AnsiString &s2)
    { // Pre: IsAdjecent (s1, s2)
    return Kant[Plads(s1)][Plads(s2)];
    }

  int           Graftype::Plads(const AnsiString &s)
    {
    int         i;
    int         index = -1;
    for (i = 0; i < Last; i++)
      if (Knude[i] == s)
	index = i;
    return index;
    }

  int           Graftype::Antal()
    {
    return Last;
    }

  String        Graftype::WhichNode(int i)
       {
    return Knude[i];
    }

#endif
